synchronisation des shapshots
Description

Also tracked in https://jira-lesia.obspm.fr/browse/RPWSWR-627 and https://jira-lesia.obspm.fr/browse/RPWSWR-628

Lorsque LFR est synchronisé par un systéme extérieur (timegen par exemple, ou la brique Star Dundee avec des time codes a 1
Hz), le centre des snapshots se décale lentement (200 ms sur 12 heures de tests). C'est di a la mise en oeuvre de la période de
répétition des snapshots, qui est basée sur I'horloge locale a 256 Hz.

Solution: contréler a chaque snapshot le décalage et ajuster le période de répétition (parameétre delta_snapshot du waveform picker).

History

#1 - 03/10/2014 09:42 AM - paul leroy

- Status changed from New to Resolved

fsw>=2.0.1.1
J'ai ajouté une fonction de resynchronisation des snapshots. Je vais détailler le fonctionnement dans le software design report.

En résumé:

Lorsqu'un snapshot a fO est généré, disons le snapshot [n], le soft regarde la date du centre et la compare a la seconde entiére la plus proche. Si la
différence est supérieure a une période a f2 (1/256 = 3.906 ms), le snapshot [n+2] est recalé, le [n+1] n'est pas modifié. La nécessité du recalage est
reconsidérée un snapshot sur deux.

#2 - 05/02/2015 08:52 AM - paul leroy

- Status changed from Resolved to Closed

fonction implémentée et testée

#3 - 18/09/2015 05:13 PM - thomas chust

- File 2015_04 07 _13 24 54 packet record NORMAL.sf0 added
- File 2015_04 07 _13_24 54 packet record NORMAL.sf1 added
- File 2015_04_07_13_24 54 packet record NORMAL.sf2 added
- File tests_time_VHDL-1.1.68_FSW-2.0.2.3 2015_04_07 added

- Priority changed from Normal to Urgent

Nouveau bug observé depuis, dans des versions récentes du soft et du VHDL:
- Bug #476 (VHDL-1.1.88 FSW-3.0.0.8)
- Bug #496 (VHDL-1.1.89 FSW-3.0.0.8)

En fait ce bug est également observé a l'identique (dans sa logique) sur une ancienne version du soft et du VHDL. A savoir:

- sous VHDL-1.1.68 et FSW-2.0.3, un enregistrement de 11 snapshots tout les 300 s (datant du 7 avril 2015) montre

- le 2émes SWF_F1 & SWF_FO0 en retard de ~0.22s par rapport a 300s (ensuite quasi nominal avec des écarts de ~12 ms tous les 2 snapshots);
- le 3¢me SWF_F2 en retard de ~0.22s (ensuite idem quasi nominal avec des écarts de ~12 ms tous les 2 snapshots);

- tous les SWF_FO0 centrés sur les SWF_F1 de maniéere identique (a 2"-16 s pres);

- ce qui implique que les 2éme SWF_F1 & SWF_FO0 sont décentrées par rapport au 2éme SWF_F2: ils sont en retard d ~0.22s

- que tous les autres SWF sont centrés de la méme maniére que le 1er snapshot, a des écarts pres de l'ordre de 12 ms tout les 2 snapshots.

Fichiers joints: tests_time_VHDL-1.1.68_FSW-2.0.2.3_2015_04_07 + les fichiers ascii des SWF

Jean-Christophe a une idée sur l'origine de cela: si j'ai bien compris, I'actualisation des décompteurs des SWF se ferait dans la méme logique que
celle qui actualise la seconde de LFR avec celle du S/C, ce qui implique une prise en compte effective tout les deux snapshots au mieux et si l'on
démarre avec des mauvais parametres cela met un certain temps a s'autocorriger ...

#4 - 18/09/2015 05:20 PM - bruno katra

- Status changed from Closed to In Progress

#5 - 04/12/2015 04:57 PM - bruno katra

- Description updated

#6 - 20/01/2016 09:54 AM - paul leroy

- Assignee changed from paul leroy to bruno katra

J'ai fait une modification dans la version 3.0.0.13 au niveau de la fonction de synchronisation des snapshots. La correction est calculée a chaque
génération d'un snapshot, c'est plus efficace.

Ceci dit, j'explique quand méme mal des décalages de centaines de ms. Une explication pour un décalage si important dans les mesures que vous
avez effectuées serait un démarrage du mode avec un enter_mode_time = 0 qui lance le mode immédiatement, sans référence a une seconde
entiére.

Ca m'a fait reconsidérer le comportement a la réception d'un enter_mode_time = 0. Pour que ce soit plus sain pour la synchro des snapshots, il
faudrait qu'en cas de réception d'un enter_mode_time = 0 je lance le mode a la date 'coarse_time local LFR + 1'. Qu'en pensez-vous?

Explication de la resynchro:

A chaque production d'un snapshot & f0, le centre de la série temporelle est mesuré et le temps avant le prochain snapshot est modifié. Tout cela se
fait avec un retard puisque a la réception d'un snapshot n, le compteur permettant de démarrer 'aacquisition du snapshot n+1 a déja été lancé. Donc
la correction calculée sur le snapshot n ne sera appliquée qu'au snapshot n+2.

#7 - 19/02/2016 10:35 AM - thomas chust
- Priority changed from Urgent to Normal

- % Done changed from 0 to 80

Pour les dernieres avancée sur ce point voir: #614

#8 - 09/03/2016 11:27 AM - bruno katra
- % Done changed from 80 to 90

Nombreuses modifications/améliorations faites par Paul entre 3.0.0.13 et 3.0.0.22 (tracés dans #612#616#618#624#630).

A partir de 3.0.0.22 ; le jitter est stable méme aprés plusieurs heures de tests : entre -11ms et +3 ms pour FO par exemple avec ne synchro
TIMEGEN. (voir graphes #630)

Une RFW 230 a été émise concernant la nc avec les 1ms demandé par SSS-CP-EQS-350.

Le jitter actuel permet néanmoins un recouvrement complet des SWF de TDS, ce qui est I'exigence scientifique voulue par SSS-CP-EQS-350.

#9 - 10/03/2016 03:28 PM - bruno katra

- Status changed from In Progress to Feedback

JIRA 627 :

After several improvements on swf resync algorithm, the centering precision of swf has a jitter which is stable and characterized (depending on
sampling frequency). 3 figures are attached in this issue showing the jitter for SWF_F0, SWF_F1 and SWF_F2 during 15 hours when LFR is
synchronized with an external sources which are approx :

FO : -11ms/+3ms

F1:-11.5ms/+3ms

F2:-14ms/+1ms

Even if more than 1ms required, those range are still scientifically acceptable as they cover TDS SWF range.
All of this has been written in RFW 230.

#10 - 24/03/2017 11:55 AM - bruno katra
- Status changed from Feedback to Closed

Pas d'objection a la RFW regu.

Files

2015_04_07_13_24 54 packet_record_NORMAL.sf0 1.08 MB 18/09/2015 thomas chust
2015_04_07_13_24 54 packet_record_NORMAL.sf2 1.08 MB 18/09/2015 thomas chust
2015_04_07_13_24 54 packet_record_NORMAL.sf1 1.08 MB 18/09/2015 thomas chust
tests_time VHDL-1.1.68 FSW-2.0.2.3_2015 04 07 11.9 KB 18/09/2015 thomas chust
